package com.wissamfawaz;

import java.time.Duration;
import java.time.Instant;
import java.util.Scanner;

public class Main {

	public static void main(String[] args) {
		int n;
		String nStr;
		Scanner scan = new Scanner(System.in);
		
		System.out.println("Enter n (q to quit): ");
		nStr = scan.nextLine();
		
		while(!nStr.equals("q")) {
			try {
				n = Integer.parseInt(nStr);
				System.out.println("Dynamic programming solution: " + 
						fib_dp(n, new long[n+1]));
				Instant before = Instant.now();
				System.out.println("Recursive solution: " + 
						fib_rec(n));
				Instant after = Instant.now();
				System.out.println("Running time of recursive solution: " + 
						Duration.between(before, after).toMillis() + " ms");
				
			} catch(NumberFormatException e) {
				System.out.println("q is the only acceptable non-int value");
			}
			
			System.out.println("Enter n (q to quit): ");
			nStr = scan.nextLine();
		}
		
		
		scan.close();

	}
	
	private static long fib_rec(int n) {
		if(n == 0 || n == 1) {
			return n;
		}
		
		return fib_rec(n-1) + fib_rec(n-2);
	}
	
	private static long fib_dp(int n, long[] cache) {
		if(cache[n] != 0) {
			return cache[n];
		}
		
		long answer;
		
		if(n == 0 || n == 1) {
			answer = n;
		} else {
			answer = fib_dp(n-1, cache) + fib_dp(n-2, cache);
		}
		
		cache[n] = answer;
		
		return answer;
		
	}
	
	
	

}
